Bug 448503 - xorg eats up lots of memory
xorg eats up lots of memory
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: xorg-x11-server (Show other bugs)
9
All Linux
high Severity high
: ---
: ---
Assigned To: Adam Jackson
Fedora Extras Quality Assurance
: Patch
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-05-27 05:57 EDT by Christoph Höger
Modified: 2018-04-11 10:11 EDT (History)
10 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-07-14 12:43:02 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Xorg.0.log (28.59 KB, text/plain)
2008-05-27 05:59 EDT, Christoph Höger
no flags Details
xorg.conf (858 bytes, text/plain)
2008-05-27 07:25 EDT, Christoph Höger
no flags Details
my xorg.conf (875 bytes, text/plain)
2008-06-01 01:32 EDT, Zing
no flags Details

  None (edit)
Description Christoph Höger 2008-05-27 05:57:41 EDT
Description of problem:
After some time X-Server uses a lot of memory:
 7077 root      20   0  612m 262m  10m S 21.2 13.2  15:47.32 Xorg

Version-Release number of selected component (if applicable):
 xorg-x11-server-Xorg-1.4.99.901-29.20080415.fc9.i386

This is not due to x caching ressources. xresourcetop shows just about 30M usage. 

Steps to Reproduce:
1. start x
2. wait a while
  
Actual results:
Memory load goes high

Expected results:
Memory load should be way lower.

Additional info:
I am using the intel driver.
Comment 1 Christoph Höger 2008-05-27 05:59:12 EDT
Created attachment 306754 [details]
Xorg.0.log
Comment 2 Matěj Cepl 2008-05-27 06:53:29 EDT
Can we get /etc/X11/xorg.conf as well, please? Anything interesting about your
setup?
Comment 3 Christoph Höger 2008-05-27 07:25:27 EDT
Created attachment 306756 [details]
xorg.conf

Nothing special there, just a standard xorg.conf created by the standard
xorg.conf creation tools ;)
Comment 4 Chris Maynard 2008-05-28 20:48:47 EDT
Any chance you are rotating your desktop background regularly? I noticed, while
running webilder, that memory is leaked every time a new background displayed.

ie. (from memory...)
for i in /usr/share/backgrounds/*; do feh --bg-center $i; done (or gconftool-2
--set /apps/desktop/background -t string $i, both with same results)

the same command with "feh $i; sleep 1; killall feh" or similar does not induce
the same results.

00:02.0 VGA compatible controller: Intel Corporation Mobile GM965/GL960
Integrated Graphics Controller (rev 0c)
00:02.1 Display controller: Intel Corporation Mobile GM965/GL960 Integrated
Graphics Controller (rev 0c)


This is on a compaq 6710b. Stock xorg.conf.

If this is related, I can grab some hard numbers and other info...
Comment 5 Christoph Höger 2008-05-29 14:56:55 EDT
Nope. No Desktop background rotations over here.
Comment 6 Zing 2008-06-01 01:31:09 EDT
I'm also seeing X memory hogging:

  PID USER      PR  NI  VIRT  RES  SHR S %CPU %MEM    TIME+  COMMAND            
16266 root      20   0  896m 183m 7904 R  0.8 18.2  29:20.97 X

xorg-x11-server-Xorg-1.4.99.901-29.20080415.fc9.x86_64
xorg-x11-drv-ati-6.8.0-14.fc9.x86_64

I did a pmap of the X process and it looks like this line grows:
00000000011f0000 272708K rw---    [ anon ]

Nothing really special about my setup.  AMD/x86_64/ATI Radeon:
06:00.0 VGA compatible controller: ATI Technologies Inc R430 [Radeon X800 XL]
(PCIe) (prog-if 00 [VGA controller])
	Subsystem: Micro-Star International Co., Ltd. Unknown device 0952

my xrestop is about 30MB also.
Comment 7 Zing 2008-06-01 01:32:04 EDT
Created attachment 307299 [details]
my xorg.conf
Comment 8 sangu 2008-06-12 05:46:54 EDT
$ sudo pmap -x 2220 
2220:   /usr/bin/Xorg :0 -br -verbose -auth
/var/run/gdm/auth-cookie-XX9R6OCU-for-gdm -nolisten tcp
Address   Kbytes     RSS    Anon  Locked Mode   Mapping
[skip/]
08c08000  599920       -       -       - rw---    [ anon ]
[/skip]
-------- ------- ------- ------- -------
total kB  727592 

  PID  PPID  UID TTY       VIRT  RES  SHR    TIME+  %CPU %MEM S COMMAND         
2220  2219    0 tty7      719m 642m  14m  17:05.66  6.7 32.0 S Xorg         

xorg eats up lots of memory in
xorg-x11-server-Xorg-1.4.99.902-2.20080612.fc9.i386 and nvidia closed source driver.
Comment 9 Zdenek Kabelac 2008-06-13 06:57:43 EDT
I'm having exactly same problem as the orginal author of this bugreport.

I'm running 64bit T61,C2D,2GB RAM
xorg-x11-server-Xorg-1.4.99.901-29.20080415.fc9.x86_64

It seems that Xorgs leaks memory with speed in range of MB per minute.
xrestop doesn't show some unusually high growing pixmap allocation.

/proc/pid/smaps seems to be showing growing heap numbers

VMSIZE:     607764 kb
RSS:        526040 kb total
              3780 kb shared
              3284 kb private clean
            174592 kb private dirty
PRIVATE MAPPINGS
     vmsize   rss clean   rss dirty   file
   70680 kb        0 kb    70552 kb
   28676 kb        0 kb    28676 kb
   27696 kb        0 kb    27696 kb
   14760 kb        0 kb    14632 kb   [heap]
   12356 kb        0 kb    12356 kb
    7020 kb        0 kb     7020 kb
    7020 kb        0 kb     7020 kb
    5936 kb        0 kb     5936 kb
     160 kb        0 kb      156 kb
      48 kb        8 kb       36 kb   /usr/bin/Xorg
      36 kb        0 kb       36 kb
      84 kb        0 kb       36 kb   [stack]
      36 kb        0 kb       36 kb

the list looks a bit different in KDE or Gnome - but both environment seems to
showing this Xorg memleak behavior.

(--) PCI:*(0@0:2:0) Intel Corporation Mobile GM965/GL960 Integrated Graphics
Controller rev 12, Mem @ 0xf8100000/1048576, 0xe0000000/268435456, I/O @
0x00001800/8
(--) PCI: (0@0:2:1) Intel Corporation Mobile GM965/GL960 Integrated Graphics
Controller rev 12, Mem @ 0xf8200000/1048576


Also I don't see any other process growing it size - or interacting with Xserver.

If there is anything I should try - just ask...
Comment 10 Zdenek Kabelac 2008-06-16 03:46:26 EDT
Update: with new version:
xorg-x11-server-Xorg-1.4.99.902-3.20080612.fc9.x86_64
I no longer experience massive & fast memory grow. But still I can see quite
large memory consumption over the time - something like 50MB/day - much better
than few days ago.

If there are any idea how to trace these leaks and still be able to work I'll
try them.

With xrestop I'm noticing these weird lines:

6200000     0    0    0    1    0     6890K      0B   6890K   ?   <unknown>
5e00000     0    0    0    1    0     6890K      0B   6890K   ?   <unknown>
Comment 11 kanagawa jigorou 2008-06-17 08:42:16 EDT
This problem may be the same with Bug 450782.
Try this patch.
http://sources.gentoo.org/viewcvs.py/gentoo-x86/x11-libs/pixman/files/pixman-0.11.4-memleak.patch?view=markup
Comment 12 Zing 2008-06-20 20:55:48 EDT
unfortunately, that didn't help me.  If others would like to give pixman .11 a
try my fc9 rebuild of pixman rawhide is here:

http://shishz.fedorapeople.org/
Comment 13 jghobrial 2009-04-20 11:48:33 EDT
cat /proc/$(pidof Xorg)/smaps
...
1b405000-40e98000 rw-p 1b405000 00:00 0                                  [heap]
Size:            617036 kB
Rss:             392420 kB
Shared_Clean:         0 kB
Shared_Dirty:         0 kB
Private_Clean:      260 kB
Private_Dirty:   392160 kB
Swap:   224520 kB
...


pmap -x $(pidof Xorg)
...

----------------  ------  ------  ------  ------
total kB         1311216       -       -       -

I see steady growth. Eventually things become slow. nvidia, twinview. RHEL 5u3.
Comment 14 Bug Zapper 2009-06-09 21:14:14 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 15 Zdenek Kabelac 2009-06-11 04:04:51 EDT
This bugzilla could be probably closed as the original source of problem - some major memory leaks were already fixed (works in F11) - though there is still yet another issue which is tracked via freedesktop bugzilla: http://bugs.freedesktop.org/show_bug.cgi?id=22171
Comment 16 Bug Zapper 2009-07-14 12:43:02 EDT
Fedora 9 changed to end-of-life (EOL) status on 2009-07-10. Fedora 9 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.